import {DatabaseSchema} from "../../app/config/databaseSchema";

var window = {};

import {CoreDatabaseService} from "../../app/services/core.database.service";

declare var importScripts, postMessage, onconnect;

let service = new CoreDatabaseService();

onmessage = (e) => {
	let method = e.data.method;
	let id = e.data.id;
	let type = e.data.type;
	let data = e.data.data;
	if(method && id && type){
		service.setConfig(DatabaseSchema.schemaDictionary[type]);
		let promise;
		switch(method) {
			case "get":
				promise = service.get(data.id);
				break;
			case "getAll":
				promise = service.getAll(data.conditions);
				break;
			case "add":
				promise = service.add(data.data);
				break;
			case "addAll":
				promise = service.addAll(data.docs);
				break;
			case "update":
				promise = service.update(data.data);
				break;
			case "updateAll":
				promise = service.updateAll(data.docs);
				break;
			case "remove":
				promise = service.remove(data.data);
				break;
			case "removeAll":
				promise = service.removeAll(data.docs);
				break;
			default:
				promise = Promise.reject("METHOD_NOT_AVAILABLE");
		}
		promise.then((response) => {
			postMessage({id,response});
		});
	}
	var workerResult = 'Result: ' + (e.data[0] * e.data[1]);
	postMessage(workerResult);
}